searchNodes=[{"doc":"Welcome to Shopifex!Configuration (All configuration options are required):app_name - This gets used in the Shopifex provided app installation page:repo - The Ecto.Repo for your application:shop_schema - Your Ecto.Schema that must have :url, :scopes, and :access_token properties. This is used to install and load stores into the session:redirect_uri - The redirect URI used in the Shopify app installation process. Must be whitelisted in your Shopify app configuration:api_key - Your Shopify app's API key:secret - Your Shopify app's secretscopes - Shopify OAuth scopes which your application requires:webhook_uri - When webhooks are created by Shopifex, this is used as the webhook endpoint:webhook_topics - Topics to subscribe to after installation is completeExample:config :shopifex, app_name: &quot;MyApp&quot;, repo: MyApp.Repo, shop_schema: MyApp.Shop, api_key: &quot;shopifyapikey123&quot;, secret: &quot;shopifyapisecret456&quot;, redirect_uri: &quot;https://myapp.ngrok.io/auth/install&quot;, scopes: &quot;read_inventory,write_inventory,read_products,write_products,read_orders&quot;, webhook_uri: &quot;https://myapp.ngrok.io/webhook&quot;, webhook_topics: [&quot;app/uninstalled&quot;]","ref":"Shopifex.html","title":"Shopifex","type":"module"},{"doc":"Fetches the flash in a way which maintains the session within Shopify iFrame","ref":"Shopifex.Plug.FetchFlash.html","title":"Shopifex.Plug.FetchFlash","type":"module"},{"doc":"","ref":"Shopifex.Plug.FetchFlash.html#call/2","title":"Shopifex.Plug.FetchFlash.call/2","type":"function"},{"doc":"","ref":"Shopifex.Plug.FetchFlash.html#init/1","title":"Shopifex.Plug.FetchFlash.init/1","type":"function"},{"doc":"","ref":"Shopifex.Plug.LoadInIframe.html","title":"Shopifex.Plug.LoadInIframe","type":"module"},{"doc":"This allows your application to load inside of an iframe by deleting the x-frame-options response header","ref":"Shopifex.Plug.LoadInIframe.html#call/2","title":"Shopifex.Plug.LoadInIframe.call/2","type":"function"},{"doc":"","ref":"Shopifex.Plug.LoadInIframe.html#init/1","title":"Shopifex.Plug.LoadInIframe.init/1","type":"function"},{"doc":"","ref":"Shopifex.Plug.ShopifyEntrypoint.html","title":"Shopifex.Plug.ShopifyEntrypoint","type":"module"},{"doc":"Ensures that the connection has a valid Shopify HMAC token in the URL param, then sets conn.private.valid_hmac in the conn. You may want to handle this in your entry point by allowing the user without a valid HMAC to an install app page.","ref":"Shopifex.Plug.ShopifyEntrypoint.html#call/2","title":"Shopifex.Plug.ShopifyEntrypoint.call/2","type":"function"},{"doc":"","ref":"Shopifex.Plug.ShopifyEntrypoint.html#init/1","title":"Shopifex.Plug.ShopifyEntrypoint.init/1","type":"function"},{"doc":"Ensures that a valid store is currently loaded in the session and is accessible in your controllers/templates as conn.private.shop","ref":"Shopifex.Plug.ShopifySession.html","title":"Shopifex.Plug.ShopifySession","type":"module"},{"doc":"","ref":"Shopifex.Plug.ShopifySession.html#call/2","title":"Shopifex.Plug.ShopifySession.call/2","type":"function"},{"doc":"","ref":"Shopifex.Plug.ShopifySession.html#init/1","title":"Shopifex.Plug.ShopifySession.init/1","type":"function"},{"doc":"","ref":"Shopifex.Plug.ShopifyWebhook.html","title":"Shopifex.Plug.ShopifyWebhook","type":"module"},{"doc":"Ensures that the connection has a valid Shopify webhook HMAC token","ref":"Shopifex.Plug.ShopifyWebhook.html#call/2","title":"Shopifex.Plug.ShopifyWebhook.call/2","type":"function"},{"doc":"","ref":"Shopifex.Plug.ShopifyWebhook.html#init/1","title":"Shopifex.Plug.ShopifyWebhook.init/1","type":"function"},{"doc":"This module acts as the context for any database interaction from within the Shopifex package.","ref":"Shopifex.Shops.html","title":"Shopifex.Shops","type":"module"},{"doc":"Check the webhooks set on the shop, then compare that to the required webhooks based on the current status of the shop.","ref":"Shopifex.Shops.html#configure_webhooks/1","title":"Shopifex.Shops.configure_webhooks/1","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#create_shop/1","title":"Shopifex.Shops.create_shop/1","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#delete_shop/1","title":"Shopifex.Shops.delete_shop/1","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#get_shop_by_url/1","title":"Shopifex.Shops.get_shop_by_url/1","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#repo/0","title":"Shopifex.Shops.repo/0","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#shop_schema/0","title":"Shopifex.Shops.shop_schema/0","type":"function"},{"doc":"","ref":"Shopifex.Shops.html#update_shop/2","title":"Shopifex.Shops.update_shop/2","type":"function"},{"doc":"The entrypoint for shopifex web interface, such as controllers, views, channels and so on.This can be used in your application as:use ShopifexWeb, :controller use ShopifexWeb, :viewThe definitions below will be executed for every view, controller, etc, so keep them short and clean, focused on imports, uses and aliases.Do NOT define functions inside the quoted expressions below. Instead, define any helper function in modules and import those modules here.","ref":"ShopifexWeb.html","title":"ShopifexWeb","type":"module"},{"doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"ShopifexWeb.html#__using__/1","title":"ShopifexWeb.__using__/1","type":"macro"},{"doc":"","ref":"ShopifexWeb.html#controller/0","title":"ShopifexWeb.controller/0","type":"function"},{"doc":"","ref":"ShopifexWeb.html#view/0","title":"ShopifexWeb.view/0","type":"function"},{"doc":"You can use this module inside of another controller to handle initial iFrame load and shop installationExample:defmodule MyAppWeb.AuthController do use MyAppWeb, :controller use ShopifexWeb.AuthController # Thats it! Validation, installation are now handled for you :) end","ref":"ShopifexWeb.AuthController.html","title":"ShopifexWeb.AuthController","type":"module"},{"doc":"","ref":"ShopifexWeb.AuthView.html","title":"ShopifexWeb.AuthView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"ShopifexWeb.AuthView.html#__resource__/0","title":"ShopifexWeb.AuthView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"ShopifexWeb.AuthView.html#render/2","title":"ShopifexWeb.AuthView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"ShopifexWeb.AuthView.html#template_not_found/2","title":"ShopifexWeb.AuthView.template_not_found/2","type":"function"},{"doc":"Include body_reader: {ShopifexWeb.CacheBodyReader, :read_body, []} in your endpoint.ex file in Plug.Parser optionsExample:... plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], body_reader: {ShopifexWeb.CacheBodyReader, :read_body, []}, json_decoder: Phoenix.json_library()","ref":"ShopifexWeb.CacheBodyReader.html","title":"ShopifexWeb.CacheBodyReader","type":"module"},{"doc":"","ref":"ShopifexWeb.CacheBodyReader.html#read_body/2","title":"ShopifexWeb.CacheBodyReader.read_body/2","type":"function"},{"doc":"Conveniences for translating and building error messages.","ref":"ShopifexWeb.ErrorHelpers.html","title":"ShopifexWeb.ErrorHelpers","type":"module"},{"doc":"Generates tag for inlined form input errors.","ref":"ShopifexWeb.ErrorHelpers.html#error_tag/2","title":"ShopifexWeb.ErrorHelpers.error_tag/2","type":"function"},{"doc":"Translates an error message using gettext.","ref":"ShopifexWeb.ErrorHelpers.html#translate_error/1","title":"ShopifexWeb.ErrorHelpers.translate_error/1","type":"function"},{"doc":"","ref":"ShopifexWeb.ErrorView.html","title":"ShopifexWeb.ErrorView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"ShopifexWeb.ErrorView.html#__resource__/0","title":"ShopifexWeb.ErrorView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"ShopifexWeb.ErrorView.html#render/2","title":"ShopifexWeb.ErrorView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"ShopifexWeb.ErrorView.html#template_not_found/2","title":"ShopifexWeb.ErrorView.template_not_found/2","type":"function"},{"doc":"A module providing Internationalization with a gettext-based API.By using Gettext, your module gains a set of macros for translations, for example:import ShopifexWeb.Gettext # Simple translation gettext(&quot;Here is the string to translate&quot;) # Plural translation ngettext(&quot;Here is the string to translate&quot;, &quot;Here are the strings to translate&quot;, 3) # Domain-based translation dgettext(&quot;errors&quot;, &quot;Here is the error message to translate&quot;)See the Gettext Docs for detailed usage.Please help me internationalize this package!","ref":"ShopifexWeb.Gettext.html","title":"ShopifexWeb.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3.","ref":"ShopifexWeb.Gettext.html#dgettext/3","title":"ShopifexWeb.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2.","ref":"ShopifexWeb.Gettext.html#dgettext_noop/2","title":"ShopifexWeb.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5.","ref":"ShopifexWeb.Gettext.html#dngettext/5","title":"ShopifexWeb.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3.","ref":"ShopifexWeb.Gettext.html#dngettext_noop/3","title":"ShopifexWeb.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4.","ref":"ShopifexWeb.Gettext.html#dpgettext/4","title":"ShopifexWeb.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"ShopifexWeb.Gettext.html#dpgettext_noop/3","title":"ShopifexWeb.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6.","ref":"ShopifexWeb.Gettext.html#dpngettext/6","title":"ShopifexWeb.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"ShopifexWeb.Gettext.html#dpngettext_noop/4","title":"ShopifexWeb.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2.","ref":"ShopifexWeb.Gettext.html#gettext/2","title":"ShopifexWeb.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1.","ref":"ShopifexWeb.Gettext.html#gettext_comment/1","title":"ShopifexWeb.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1.","ref":"ShopifexWeb.Gettext.html#gettext_noop/1","title":"ShopifexWeb.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2.","ref":"ShopifexWeb.Gettext.html#handle_missing_bindings/2","title":"ShopifexWeb.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6.","ref":"ShopifexWeb.Gettext.html#handle_missing_plural_translation/6","title":"ShopifexWeb.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4.","ref":"ShopifexWeb.Gettext.html#handle_missing_translation/4","title":"ShopifexWeb.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"ShopifexWeb.Gettext.html#lgettext/5","title":"ShopifexWeb.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"ShopifexWeb.Gettext.html#lngettext/7","title":"ShopifexWeb.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4.","ref":"ShopifexWeb.Gettext.html#ngettext/4","title":"ShopifexWeb.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2.","ref":"ShopifexWeb.Gettext.html#ngettext_noop/2","title":"ShopifexWeb.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3.","ref":"ShopifexWeb.Gettext.html#pgettext/3","title":"ShopifexWeb.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"ShopifexWeb.Gettext.html#pgettext_noop/2","title":"ShopifexWeb.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5.","ref":"ShopifexWeb.Gettext.html#pngettext/5","title":"ShopifexWeb.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"ShopifexWeb.Gettext.html#pngettext_noop/3","title":"ShopifexWeb.Gettext.pngettext_noop/3","type":"macro"},{"doc":"","ref":"ShopifexWeb.LayoutView.html","title":"ShopifexWeb.LayoutView","type":"module"},{"doc":"The resource name, as an atom, for this view","ref":"ShopifexWeb.LayoutView.html#__resource__/0","title":"ShopifexWeb.LayoutView.__resource__/0","type":"function"},{"doc":"Renders the given template locally.","ref":"ShopifexWeb.LayoutView.html#render/2","title":"ShopifexWeb.LayoutView.render/2","type":"function"},{"doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template.","ref":"ShopifexWeb.LayoutView.html#template_not_found/2","title":"ShopifexWeb.LayoutView.template_not_found/2","type":"function"},{"doc":"You can use this module inside of another one of your application controllers. The conn, shop and topic will be called by handle_topic/3 which you can define in your parent controller.Example:use ShopifexWeb.WebhookController def handle_topic(conn, shop, &quot;app/uninstalled&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(200, &quot;success&quot;) end # Mandatory Shopify shop data erasure GDPR webhook. Simply delete the shop record def handle_topic(conn, shop, &quot;shop/redact&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(204, &quot;&quot;) end # Mandatory Shopify customer data erasure GDPR webhook. Simply delete the shop (customer) record def handle_topic(conn, shop, &quot;customers/redact&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(204, &quot;&quot;) end # Mandatory Shopify customer data request GDPR webhook. def handle_topic(conn, _shop, &quot;customers/data_request&quot;) do # Send an email of the shop data to the customer. conn |&gt; send_resp(202, &quot;Accepted&quot;) end","ref":"ShopifexWeb.WebhookController.html","title":"ShopifexWeb.WebhookController","type":"module"},{"doc":"","ref":"ShopifexError.html","title":"ShopifexError","type":"exception"},{"doc":"ShopifexA simple boilerplate package for creating Shopify embedded apps with the Elixir Phoenix framework. https://hexdocs.pm/shopifexFor from-scratch setup instructions, read Create and Elixir Phoenix Shopify App in 5 Minutes","ref":"readme.html","title":"Shopifex","type":"extras"},{"doc":"The package can be installed by adding shopifex to your list of dependencies in mix.exs:def deps do [ {:shopifex, &quot;~&gt; 0.1.2&quot;} ] end","ref":"readme.html#installation","title":"Shopifex - Installation","type":"extras"},{"doc":"Add the :shopifex config settings to your config.ex. More config details hereconfig :shopifex, app_name: &quot;MyApp&quot;, shop_schema: MyApp.Shop, repo: MyApp.Repo, redirect_uri: &quot;https://myapp.ngrok.io/auth/install&quot;, webhook_uri: &quot;https://myapp.ngrok.io/webhook&quot;, scopes: &quot;read_inventory,write_inventory,read_products,write_products,read_orders&quot;, api_key: &quot;shopifyapikey123&quot;, secret: &quot;shopifyapisecret456&quot;, webhook_topics: [&quot;app/uninstalled&quot;]Update your endpoint.ex to include the custom body parser. This is necessary for HMAC validation to work.plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], body_reader: {ShopifexWeb.CacheBodyReader, :read_body, []}, json_decoder: Phoenix.json_library()Update your router.ex to include the Shopifex plugs# Make your browser pipeline look like this pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug Shopifex.Plug.FetchFlash plug :protect_from_forgery plug :put_secure_browser_headers plug Shopifex.Plug.LoadInIframe end # Ensures that a valid store is currently loaded in the session and is accessible in your controllers/templates as `conn.private.shop` pipeline :shopify_session do plug Shopifex.Plug.ShopifySession end # Make sure the incoming requests from Shopify are valid. For example, when the app is being installed, or the initial loading of your App inside of the Shopify admin panel. pipeline :shopify_entrypoint do plug Shopifex.Plug.ShopifyEntrypoint end # Ensures that the connection has a valid Shopify webhook HMAC token pipeline :shopify_webhook do plug Shopifex.Plug.ShopifyWebhook endNow add this basic example of these plugs in action in router.exscope &quot;/auth&quot;, MyAppWeb do pipe_through [:browser, :shopify_entrypoint] get &quot;/&quot;, AuthController, :auth get &quot;/install&quot;, AuthController, :install end scope &quot;/&quot;, MyAppWeb do pipe_through [:browser, :shopify_session] get &quot;/&quot;, PageController, :index end scope &quot;/webhook&quot;, MyAppWeb do pipe_through [:shopify_webhook] post &quot;/&quot;, WebhookController, :action endCreate a new controller called auth_controller.ex to handle the initial iFrame load and installationdefmodule MyAppWeb.AuthController do use MyAppWeb, :controller use ShopifexWeb.AuthController # Thats it! Validation, installation are now handled for you :) endcreate another controller called webhook_controller.ex to handle incoming Shopify webhooksdefmodule MyAppWeb.WebhookController do use MyAppWeb, :controller use ShopifexWeb.WebhookController # add as many handle_topic/3 functions here as you like! This basic one handles app uninstallation def handle_topic(conn, shop, &quot;app/uninstalled&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(200, &quot;success&quot;) end # Mandatory Shopify shop data erasure GDPR webhook. Simply delete the shop record def handle_topic(conn, shop, &quot;shop/redact&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(204, &quot;&quot;) end # Mandatory Shopify customer data erasure GDPR webhook. Simply delete the shop (customer) record def handle_topic(conn, shop, &quot;customers/redact&quot;) do Shopifex.Shops.delete_shop(shop) conn |&gt; send_resp(204, &quot;&quot;) end # Mandatory Shopify customer data request GDPR webhook. def handle_topic(conn, _shop, &quot;customers/data_request&quot;) do # Send an email of the shop data to the customer. conn |&gt; send_resp(202, &quot;Accepted&quot;) end end","ref":"readme.html#quickstart","title":"Shopifex - Quickstart","type":"extras"},{"doc":"You can also update the app permissions after installation. To do so, first you have to add your-redirect-url.com/auth/update to Shopify's whitelist.Then add the following route to your /auth scope:scope &quot;/auth&quot;, MyAppWeb do ... get &quot;/update&quot;, AuthController, :update endTo add e.g. the read_customers scope, you can do so by redirecting them to the following example url:https://{shop-name}.myshopify.com/admin/oauth/request_grant?client_id=API_KEY&amp;redirect_uri={YOUR_REDIRECT_URL}/auth/update&amp;scope={YOUR_SCOPES},read_customers","ref":"readme.html#update-app-permissions","title":"Shopifex - Update app permissions","type":"extras"}]